//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
//
//  This code is distributed under the GNU Public License
//  which can be found at http://www.gnu.org/licenses/gpl.txt
//
//----------------------------------------------------------------------------
// File Name           : HandleDDS.h
// Object              : QROlleSAM7S Board Features Definition File.
//
// Creation            : NSn   20080111
//----------------------------------------------------------------------------


// Setup and define values for AD9951
#define CONTROLFUNCTIONREG_1				0
#define CONTROLFUNCTIONREG_2				1
#define AMPLITUDESCALEFACTOR				2
#define AMPLITUDERAMPRATE						3
#define FREQUENCYTUNINGWORD					4
#define PHASEOFFSETWORD							5

#define MSBCONTROLBYTE_RESET		0x21
#define MSBCONTROLBYTE					0x20
#define LSBCONTROLBYTE					0x00

#define MSBFQ_0_BYTEWMASK				0x40

enum { ADDING, SUBTRACTING, TRANSVERTEROFFSET };

/*
extern volatile UINT			Present_A_Frequency;
extern volatile UINT			Present_B_Frequency;
extern 					UINT			RXfrequency;
extern 					UINT			TXfrequency;
extern 					UINT			RITfrequency;
extern 					UINT			SGfrequency;
extern 					UINT			RITOffsetfrequency;
extern	volatile UINT					AD9834frequency;
*/
extern	struct 	FQvalues		RAM;

extern	volatile 	UINT			FqStep;

extern volatile BYTE			DirectionOfRotation;
extern volatile WORD			timingInBuffer;
extern	volatile WORD			LastPulseCount;
extern	volatile WORD			PulseCount;
extern	volatile WORD			PulseAverage;
extern	volatile BYTE 			IncreaseFQ;

//++++++++++++++++++++++++++++++++++++++++++++

extern void UpdateFrequency ( UINT * frequency );
extern void 	init_DDS_chip ( const AT91PS_SPI pSpi );
extern void  send2DDS ( BYTE register_in_DDS, BYTE value );
extern BYTE  readFromDDS ( BYTE register_in_DDS );
extern void	CalculateFrequencyDivisor ( UINT frequency );
extern void SaveRXfq ( void );
extern void RestoreRXfq ( void );
extern void RestoreRITfq ( void );
extern void SaveRITfq ( void );
extern void UpdateDisplay ( void );
extern void SendDivisor2DDS ( const AT91PS_SPI pSPI );
extern void SaveDDSfactors ( void );
extern void GetDDSfactors ( void );
extern void	CalculateDDSfractions ( UINT AD9834RefFrequency );

