/* Copyright (C) 2005 MediTalk AB 

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
#ifndef __COMMANDS_INCLUDED
#define __COMMANDS_INCLUDED

#define ERROR_NO_COMMAND 0xFF

#define COMMAND_NOT_IMPLEMENTED "Command not implemented;\n\r"
#define NEW_LINE  '\n'
#define RETURN  '\r'
#define SEMICOLON  ';'

#define Kenwood     0x1
#define Yaesu       0x2
#define AllEqu     Kenwood + Yaesu
extern	BYTE				K2mode;
extern	volatile UINT			Present_A_Frequency;
extern	volatile UINT			Present_B_Frequency;

enum freq { NO_CHANNEL, A_FREQUENCY, B_FREQUENCY };

//Prototypes
extern BYTE CommandHandle ( void );
static void MsgNotImplemented ( void );
static void  VfoA2VfoB ( void );
static void  AntTuner ( void );
static void  AFgain ( void );
static void  AutoInfo ( void );
static void  Antenn ( void );
static void  AutoNotch ( void );
static void  BandDown ( void );
static void	BreakIn ( void );
static void	ManualNotch ( void );
static void  BandSelect ( void );
static void  BandUp ( void );
static void  IsBusy ( void );
static void  Contour ( void );
static void  CWspot ( void );
static void  CTSS ( void );
static void  Dimmer ( void );
static void  MicDown ( void );
static void  Displaying ( void );
static void  DimmerSwitch ( void );
static void  FQAsetting ( void );
static void  FQBsetting ( void );
static void  FunctionKey ( void );
static void  FastStep ( void );
static void  FunctionRX ( void );
static void  FunctionTX ( void );
static void  AGCfunction ( void );
static void  Ident ( void );
static void  Info ( void );
static void  IFshift ( void );
static void  KeyPitch ( void );
static void  Keyer ( void );
static void  KeySpeed ( void );
static void  DialLock ( void );
static void  ModeSet ( void );
static void  MicGain ( void );
static void  ModeKey ( void );
static void  MonitorLevel ( void );
static void  MeterSw ( void );
static void  MoxSet ( void );
static void  Narrow ( void );
static void  NoiseBlanker ( void );
static void  NoiseReduction ( void );
static void  PreAmpStatus ( void );
static void  PowerCtrl ( void );
static void  SpeechProcessor ( void );
static void  PowerSwitch ( void );
static void  QuickSplit ( void );
static void  RFattenuator ( void );
static void  ClarClear ( void );
static void  ClarDown ( void );
static void  ClarUp ( void );
static void  ClarOnOff ( void );
static void  RoofFilter ( void );
static void  RfGain ( void );
static void  RadioInfo ( void );
static void  NoiseReductionLevel ( void );
static void  ReadMeter ( void );
static void  RadioStatus ( void );
static void  Scan ( void );
static void  BreakInTime ( void );
static void  Width ( void );
static void  SMeter ( void );
static void  SwapVFO ( void );
static void  Txw ( void );
static void  TxSet ( void );
static void  Unlock ( void );
static void  Up ( void );
static void  VoxDelay ( void );
static void  VoxGain ( void );
static void  VFOselect ( void );
static void  Vox ( void );
static void SetORsendFQvalue ( char fqmode, UINT * fqValue );
static UINT MakeString2UINT ( char * instring);
static BYTE MakeString2BYTE ( char * instring, BYTE InstringLength );
static WORD MakeString2WORD ( char * instring, BYTE InstringLength );

extern void  NotImplemented ( void );

#endif
//End of COMMANDS.H
