//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
//
//  This code is distributed under the GNU Public License
//  which can be found at http://www.gnu.org/licenses/gpl.txt
//
//----------------------------------------------------------------------------
// File Name           : menu.h
// Object              : QROlleSAM7S Board Features Definition File.
//
// Creation            : NSn   20080111
//----------------------------------------------------------------------------

#define NOMORECHANGESTEP			13
#define OUTPUTDATASIZE				11

#define POSFQ						 0
#define POSPOT1					10
#define POSPOT2					13
#define POSADC					16
#define POS_SMETER			13

#define NUMBER_OF_VOLUMEPOT_STEPS  24
#define VOLUMEPOT_STEPSIZE  11 /*((255/NUMBER_OF_VOLUMEPOT_STEPS)+1)*/
#define NUMBER_OF_POWERPOT_STEPS  32
#define POWERPOT_STEPSIZE  8 /*((255/NUMBER_OF_POWERPOT_STEPS)+1)*/
extern volatile BYTE 						handleMenuItem;
extern BYTE 										MenuActivated;
extern volatile BYTE 						ControlChanged;

extern	volatile BYTE					ADCchannel;
extern	volatile BYTE					OutputdataDirty;
extern	volatile BYTE					ADCchanneldataDirty;
extern	volatile BYTE					AD9834dataDirty;
extern	volatile BYTE					POT1dataDirty;
extern	volatile BYTE					PowerdataDirty;
extern	volatile BYTE					KnobGoingActive;
extern volatile char  				OutputBits [ OUTPUTDATASIZE ];
extern volatile BYTE 					CursorJump;
extern volatile BYTE 					OutputBitPointer;
extern volatile BYTE 					ChangeDirection;
extern volatile BYTE 					ValueChanged;
extern volatile BYTE 					CursorPosition;
extern volatile BYTE 					subfunction;
extern volatile WORD 					subfunctiontiming;
extern volatile BYTE           bSMeterDisplay;
extern const char             cSetBaudrate [];
extern const char             cBaudrateNow [];


enum menuposition { NOSELECTION, HANDLE_MENU, OK_MENU, MENU_START };
enum	changedirection { NONE, MOVEUP, MOVEDOWN };

void Menu ( void );
void MenuText ( BYTE * string, BYTE position, BYTE length );
void CleanDisplay ( void );
void InitMenu ( void );
void MakeWord2string ( char * data, WORD value, BYTE position );
void MakeByte2string ( char * data, BYTE value, BYTE position );
void Make2HEXstringByte ( char * data, BYTE value, BYTE position );
BYTE	CheckEncoderWORD ( WORD volatile * Value2adjust, WORD MaxValue, WORD steps );
BYTE	CheckEncoderBYTE ( BYTE * Value2adjust, BYTE MaxValue, BYTE steps );
BYTE	CheckEncoderLETTER ( BYTE * Value2adjust );
void SetPot1Volume ( void );
void SetPowerLevel ( void );
void SetAD9834value ( void );
void SaveBandData ( BYTE band, BYTE OffsetInStruct, BYTE WriteSize );
void SetBandData ( BYTE band );
void	SetBugSpeedStart ( void );
void	SetBugSpeed ( void );
void BreakInDelayStart ( void );
void BreakInDelay ( void );
void SetFrequencyDivisorStart ( void );
void	SetFrequencyDivisor ( void );
void	SaveFrequencyDivisor ( void );
void SetDdsRefFrequencyStart ( void );
void SetDdsRefFrequency ( void );
void 	ShowRealBugSpeed ( void );
void Voltages ( void );
void ShowBoardVoltage ( UINT VoltageValue, BYTE position );
void SetDisplayMode ( void );
void SetIambicMode ( void );
void SetBugConnect ( void );
void  Check4bandlimits ( UINT * FQ2change, BYTE band );
void SetButtonSound ( void );
